$ErrorActionPreference = 'Stop';

# Define URLs and checksums for each platform
$packageArgsX86 = @{
    packageName    = 'WiresockVpnClient'
    fileType       = 'msi'
    url            = 'https://www.wiresock.net/sdc_download/911/?key=yt5r7yu8kxvah4lctq3477gtrlyk94'
    checksum       = '16A6FB157D4CEB2EA57892CBB1F3B635F61A6919A218148FD46AB6664D3EB3D9'
    checksumType   = 'sha256' # or another checksum type (e.g., sha256)
    silentArgs     = '/qn'
    validExitCodes = @(0, 3010, 1641)
}

$packageArgsX64 = @{
    packageName    = 'WiresockVpnClient'
    fileType       = 'msi'
    url            = 'https://www.wiresock.net/sdc_download/909/?key=800439ju4unkj0zn5o7y3ve469bvtg'
    checksum       = '3E211302D0C9AAA36DC7AD584EBD1D955D7E9589D188DF737CDBB2AC36CFCF56'
    checksumType   = 'sha256' # or another checksum type (e.g., sha256)
    silentArgs     = '/qn'
    validExitCodes = @(0, 3010, 1641)
}

$packageArgsARM64 = @{
    packageName    = 'WiresockVpnClient'
    fileType       = 'msi'
    url            = 'https://www.wiresock.net/sdc_download/912/?key=rjxd1vi7gdwgknwo342jq43mkrwlxq'
    checksum       = '094971AEB54A664D70765B86CC0ADD17DD6BEE45E67BFF7565E015190B6B767E'
    checksumType   = 'sha256' # or another checksum type (e.g., sha256)
    silentArgs     = '/qn'
    validExitCodes = @(0, 3010, 1641)
}

# Detect platform
if ([System.Environment]::Is64BitOperatingSystem -and (Get-WmiObject Win32_Processor).AddressWidth -eq 64) {
    $isARM64 = $false
    try {
        $isARM64 = (Get-WmiObject Win32_ComputerSystem).SystemType -like "*ARM64*"
    } catch {
        # Fallback if the WMI query fails
        $isARM64 = $false
    }
    
    if ($isARM64) {
        $packageArgs = $packageArgsARM64
    } else {
        $packageArgs = $packageArgsX64
    }
} else {
    $packageArgs = $packageArgsX86
}

# Install the package
Install-ChocolateyPackage @packageArgs
